/* $Id: base64.c 14 2023-04-19 12:47:31Z nishi $ */
#include <swinehub/base64.h>

#include <stdlib.h>
#include <string.h>

#define OUT_SIZE 4096

char* swinehub_base64_decode(const char* str){
	char* out = malloc(OUT_SIZE + 1);
	memset(out, 0, OUT_SIZE + 1);
	int out_idx =0;
	int in_idx = 0;
	unsigned char a1 = 0, a2 = 0, a3 = 0, a4 = 0;
	int i;
	while(in_idx < strlen(str)){
		for(i = 0; i < 64; i++){
			if(str[in_idx] == base64_alphabet[i]) a1 = i;
			if(str[in_idx + 1] == base64_alphabet[i]) a2 = i;
			if(str[in_idx + 2] == base64_alphabet[i]) a3 = i;
			if(str[in_idx + 3] == base64_alphabet[i]) a4 = i;
		}
		out[out_idx] = (a1 << 2) | (a2 >> 4);
		out[out_idx + 1] = (a2 << 4) | (a3 >> 2);
		out[out_idx + 2] = (a3 << 6) | (a4);
		out_idx += 3;
		in_idx += 4;
		a1 = 0;
		a2 = 0;
		a3 = 0;
		a4 = 0;
	}
	return out;
}
